/*
 * Copyright (C) 2014 Mikel Penagarikano
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package edu.gtts.mediaevalquesst2015;

import java.util.Arrays;
import java.util.Comparator;

/**
 *
 * @author mpenagar
 */
public class Util {
	
	/**
	 * Sorts an array of doubles and returns the sorted indexes
	 * @param v The data array to be sorted
	 * @param keepUnsorted if set to true, the data array is keept unsorted,
	 * otherwise it is sorted
	 * @return The integer array containing the sorted indexes
	 */
	public static int[] indexSort(final double[] v, boolean keepUnsorted) {
		final Integer[] II = new Integer[v.length];
		for (int i = 0; i < v.length; i++) II[i] = i;
		Arrays.sort(II, new Comparator<Integer>() {
			@Override
			public int compare(Integer o1, Integer o2) {
				return Double.compare(v[o1],v[o2]);
			}
		});
		int[] ii = new int[v.length];
		for (int i = 0; i < v.length; i++) ii[i] = II[i];
		if (!keepUnsorted) {
			double[] clon = v.clone();
			for (int i = 0; i < v.length; i++) v[i] = clon[II[i]];
		}
		return ii;
	}
	
	public static double[] toPrimitive(Double[] a){
		double[] v = new double[a.length];
		for (int i = 0; i < v.length; i++) v[i] = a[i];
		return v;
	}
	public static boolean[] toPrimitive(Boolean[] a){
		boolean[] v = new boolean[a.length];
		for (int i = 0; i < v.length; i++) v[i] = a[i];
		return v;
	}

	
}

